<?php
/*
 * PHP-Script zum Erstellen von Ganglinien-Grafiken aus der Abfrage getGanglinienImage
 * des Pegelonline Webservice Aktuell Version 2.3 
 *
 * Erwartet folgende Parameter (mittels GET-Request):
 * 	PegelonlineParameter - Name eines PegelonlineParameters
 * 	PegelonlineMessstellen - Array mit Namen von PegelonlineMessstellen
 * 	DateFrom - Beginn des darzustellenden Zeitraumes (Format 'd.m.Y')
 * 	DateTo - Ende des darzustellenden Zeitraumes (Format 'd.m.Y')
 * 
 * Vorraussetzungen:
 * 	- PHP Soap Extension in php.ini deklariert (extension=php_soap.dll)
 *  - PHP GD2-Library in php.ini deklariert (extension=php_gd2.dll)
 * 	- mindestens PHP Version 5.1
 * 
 * Link: http://www.pegelonline.wsv.de/webservice/aktuell.jsp
 */
include("pegelonline_webservice_aktuell_clientapi_v2_4.php");

$selectedParameter = isset($_GET['PegelonlineParameter']) ? $_GET['PegelonlineParameter'] : "";
$messstelleRight = isset($_GET['PegelonlineMessstellen']) ? array_map("utf8_decode",$_GET['PegelonlineMessstellen']) : "";
$dateFrom = isset($_GET['DateFrom']) ? $_GET['DateFrom'] : "";
$dateTo = isset($_GET['DateTo']) ? $_GET['DateTo'] : "";

$clientApi = new PegelonlineWebserviceClientApiVersion2_4();

try {
	$data = $clientApi->getGanglinienImage($selectedParameter, null, $messstelleRight, $dateFrom, $dateTo, "90", "60");
	$im = imagecreatefromstring($data);
	if ($im !== false) {
	    header('Content-Type: image/gif');
	    imagegif($im);
	}
	else {
	    echo 'Es trat ein Fehler auf.';
	}
}
catch (Exception $e){
	echo 'Es trat ein Fehler auf.';
}

?>