<?php
/*
 * PHP-Script zum Darstellen von Pegelinformationen im einer HTML-Tabelle
 * 
 * Wird vom PHP-Client eingebunden, wenn Pegelinformationen angefordert werden
 * 
 * Author: Moritz Mller, EES GmbH, mail: m.mueller@ees-gmbh.de
 * 
 * Link: http://www.pegelonline.wsv.de/webservice/aktuell.jsp
 */

$arrPegelinformationen = $clientApi->getPegelinformationen($selectedParameter, null, $messstelleRight);

echo <<<HEAD
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<meta name="author" content="EES GmbH, www.ees-gmbh.de; Im Auftrag der: Bundesanstalt fr Wasserbau, Fachstelle der Wasser- und Schifffahrtsverwaltung fr Informationstechnik (F-IT),    Referat IT2 Gewsserkunde, Am Ehrenberg 8, 98693 Ilmenau">
<title>Pegelinformationen</title>
</head>
<body>
HEAD;
	if(!empty($arrPegelinformationen)){
		echo <<<TABLEHEADER
		<table border='1'>
		<tr>
		<td>Gewaesser</td>
		<td>Parameter</td>
		<td>Pegelname</td>
		<td>Km</td>
		<td>Pegel-Rechtswert</td>
		<td>Pegel-Hochwert</td>
		<td>Pegel-Koordinatensystem</td>
		<td>Messwert</td>
		<td>Datum</td>
		<td>Uhrzeit</td>
		<td>Tendenz</td>
		<td>Pnp</td>
		<td>Rechtswert</td>
		<td>Hochwert</td>
		<td>Koordinatensystem</td>
		</tr>\n
TABLEHEADER;
			
		foreach ($arrPegelinformationen as $pegelinformation) {
			//var_dump($pegelinformation->pegelonlineFlussgebiet->name);
			//var_dump($pegelinformation->pegelonlineFlussgebiet);
			//var_dump($pegelinformation);
			echo "<tr>\n";
			echo "<td>" . htmlentities($pegelinformation->pegelonlineGewaesser->name, ENT_QUOTES, "UTF-8") . "</td>\n";
			echo "<td>" . htmlentities($pegelinformation->pegelonlineParameter->name, ENT_QUOTES, "UTF-8") . "</td>\n";
			
			echo "<td>" . htmlentities($pegelinformation->pegelonlineMessstelle->name, ENT_QUOTES, "UTF-8") . "</td>\n";
			echo "<td>" . (!empty($pegelinformation->pegelonlineMessstelle->kilometerstand) ?  number_format($pegelinformation->pegelonlineMessstelle->kilometerstand, 2, ',', '') : "&nbsp;") . "</td>\n";
			echo "<td>" . (!empty($pegelinformation->pegelonlineMessstelle->pegelonlineKoordinate->rechtswert) ? number_format($pegelinformation->pegelonlineMessstelle->pegelonlineKoordinate->rechtswert, 2, ',', '.') : "&nbsp;") . "</td>\n";
			echo "<td>" . (!empty($pegelinformation->pegelonlineMessstelle->pegelonlineKoordinate->hochwert) ? number_format($pegelinformation->pegelonlineMessstelle->pegelonlineKoordinate->hochwert, 2, ',', '.') : "&nbsp;") . "</td>\n";
			echo "<td>" . (!empty($pegelinformation->pegelonlineMessstelle->pegelonlineKoordinate->pegelonlineKoordinatensystem) ? htmlentities($pegelinformation->pegelonlineMessstelle->pegelonlineKoordinate->pegelonlineKoordinatensystem->streifenZone, ENT_QUOTES, "UTF-8") : "&nbsp;") . "</td>\n";
			
			echo "<td>" . $pegelinformation->pegelonlineAktuelleMessung->messwert . "</td>\n";
		
			
			echo "<td>" . $clientApi->toDateTime($pegelinformation->pegelonlineAktuelleMessung->zeitpunkt)->format('d.m.Y') . "</td>\n";
			
			echo "<td>" . $clientApi->toDateTime($pegelinformation->pegelonlineAktuelleMessung->zeitpunkt)->format('H:i') . "</td>\n";
			echo "<td>" . $pegelinformation->pegelonlineAktuelleMessung->tendenz . "</td>\n";
			
			echo "<td>" . (!empty($pegelinformation->pegelonlinePegelnullpunkt->hoehe) ? number_format($pegelinformation->pegelonlinePegelnullpunkt->hoehe, 2, ',', '') : "&nbsp;") . "</td>\n";
			
			echo "<td>" . (!empty($pegelinformation->pegelonlineKoordinate->rechtswert) ? number_format($pegelinformation->pegelonlineKoordinate->rechtswert, 2, ',', '.') : "&nbsp;") . "</td>\n";
			echo "<td>" . (!empty($pegelinformation->pegelonlineKoordinate->hochwert) ? number_format($pegelinformation->pegelonlineKoordinate->hochwert, 2, ',', '.') : "&nbsp;") . "</td>\n";
			echo "<td>" . (!empty($pegelinformation->pegelonlineKoordinate->pegelonlineKoordinatensystem->streifenZone) ? htmlentities($pegelinformation->pegelonlineKoordinate->pegelonlineKoordinatensystem->streifenZone, ENT_QUOTES, "UTF-8") : "&nbsp;" ) . "</td>\n";
			
			echo "</tr>\n";
		}
		echo "</table>";
	}

	echo "</body>\n</html>";


?>