<?php
/*
 * Beispielhafter PHP-Client fr den Pegelonline Webservice Aktuell Version 2.4 
 * 
 * Vorraussetzungen:
 * 	- PHP Soap Extension in php.ini deklariert (extension=php_soap.dll)
 *  - PHP GD2-Library in php.ini deklariert (extension=php_gd2.dll)
 * 	- mindestens PHP Version 5.1
 * 
 * Link: https://pegelonline.wsv.de/webservice/aktuell.jsp
 * 
 */
include("pegelonline_webservice_aktuell_clientapi_v2_4.php");

$selectedParameter = isset($_POST['ParameterSelectionList']) ? $_POST['ParameterSelectionList'] : "";
$gewaesserRight = isset($_POST['GewaesserRightSelectionList']) ? $_POST['GewaesserRightSelectionList'] : "";
$messstelleRight = isset($_POST['MessstelleRightSelectionList']) ? $_POST['MessstelleRightSelectionList'] : "";
$dateFrom = isset($_POST['DateFrom']) ? $_POST['DateFrom'] : "";
$dateTo = isset($_POST['DateTo']) ? $_POST['DateTo'] : "";

$clientApi = new PegelonlineWebserviceClientApiVersion2_4();
$arrParameter = $clientApi->getParameterList();
$arrGewaesserLeft = $clientApi->getGewaesserList($selectedParameter);
$arrMessstelleLeft = $clientApi->getMessstellenList($selectedParameter, $gewaesserRight);

$datenVerfuegbarkeit = $clientApi->getDatenverfuegbarkeit($selectedParameter, null, $messstelleRight);
//Zip-Download
if($_POST['Download'] == "Download"){
	if((empty($dateFrom) || empty($dateTo) || ($clientApi->toW3CDateTime($dateFrom) > $clientApi->toW3CDateTime($dateTo)))){
		$downloadHinweis = "<tr><td colspan=\"3\"><span style=\"color:#ff0000\">Bitte w&auml;hlen Sie einen g&uuml;ltigen Zeitraum aus!</span></td></tr>";
	} else {
		$zipstream = $clientApi->getMessungenDatei($selectedParameter, null, $messstelleRight, $dateFrom, $dateTo);
		header('Content-type: application/zip');
		header('Content-Disposition: attachment; filename=download.zip');
		echo $zipstream;
		exit();
	}
//Ganglinie anzeigen
} elseif ($_POST['Show'] == "Ganglinie"){
	if((empty($dateFrom) || empty($dateTo) || ($clientApi->toDateTime($clientApi->toW3CDateTime($dateFrom)) < $clientApi->toDateTime($clientApi->toW3CDateTime($dateTo))))){
		header('Location: ' . $clientApi->getGanglinienUrl($selectedParameter, null, $messstelleRight, $dateFrom, $dateTo, false, "pegelonline-relaunch"));
		exit();
	}
//Pegelinformationen aufrufen
} elseif ($_POST['Pegelinformation'] == "Pegelinformationen"){
	include("pegelinformation.php");
	exit();
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Gew&auml;sserkundliches Informationssystem der Wasser- und
Schifffahrtsverwaltung</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="author"
	content="EES GmbH, www.ees-gmbh.de; Im Auftrag der: Bundesanstalt f&uuml;r Wasserbau, Fachstelle der Wasser- und Schifffahrtsverwaltung f&uuml;r Informationstechnik (F-IT),    Referat IT2 Gew&auml;sserkunde, Am Ehrenberg 8, 98693 Ilmenau">
<script language="JavaScript" type="text/javascript">
<!--
	var gewaesserRightSelectionList;
	var gewaesserLeftSelectionList;
	var messstelleLeftSelectionList;
	var messstelleRightSelectionList;
	
	function init(){
		gewaesserRightSelectionList = document.forms["form"].elements["GewaesserRightSelectionList[]"];
		gewaesserLeftSelectionList = document.forms["form"].elements["GewaesserLeftSelectionList[]"];
		messstelleLeftSelectionList  = document.forms["form"].elements["MessstelleLeftSelectionList[]"];
		messstelleRightSelectionList  = document.forms["form"].elements["MessstelleRightSelectionList[]"];
		
	}
	
	function sortArray(Right){
		var j = Right.length;
		nameArray = new Array(j);
		for (var i=0; i < j; i++) {
			nameArray[i] =  Right[i].text +"|" + Right[i].value;
			//nameArray[i]["value"] = Right[i].value;
		}
		nameArray.sort();
		deleteAllItemsFromRight(Right);
		for (var i=0; i < j; i++) {
			Right[i] = new Option(nameArray[i].substring(0,nameArray[i].indexOf("|")),nameArray[i].substring(nameArray[i].indexOf("|")+1,nameArray[i].length), 0, false);
		}
	}
	function isItemAlreadyAtRight(item, Right){
		for (var i=0; i < Right.length; i++) {
			if (item.value == Right[i].value) {
				return(true);
			}
		}
		return(false);
	}
		
	function moveSelectedItemsToRight(Left, Right){
		for (var i=0; i < Left.length; i++) {
		
			if (Left[i].selected) {
				if (!isItemAlreadyAtRight(Left[i], Right)) {
					Right[Right.length] = new Option(Left[i].text, Left[i].value, 0, false);
					Right[Right.length-1].selected = false; // fuer NN, sonst ist neues option automatisch selected
				}
			}
		}
		sortArray(Right);
		deleteSelectedItemsFromRight(Left)
	}
	
	function selectAll(Left){
		for (var i=0; i < Left.length; i++) {
			Left[i].selected=true;
		}
	}
	
	function moveAllItemsToRight(Left, Right){
		selectAll(Left);
		moveSelectedItemsToRight(Left, Right);
	}
	
	function deleteSelectedItemsFromRight(Right){
		for (var i=0; i < Right.length; i++) {
			if (Right[i].selected) {
				Right.options[i] = null;
				i=0;
			}
			
		}
		if(Right.length==1 && Right[0].selected){
			Right.options[0] = null;
		}
	}
	
	function deleteAllItemsFromRight(Right){
		selectAll(Right);
		deleteSelectedItemsFromRight(Right);
	}

	function validator(theForm){			
		selectAll(theForm.MessstelleRightSelectionList);
		if (theForm.MessstelleRightSelectionList.selectedIndex == -1)
	  {
	    alert("Waehlen sie mindestens eine Messstelle");
	    theForm.MessstelleLeftSelectionList.focus();
	    return (false);
	  }
		
	  return (true);
	}
	
	function submitForm(theForm) {
		theForm.Show.value="";
		theForm.submit();
	}
	
	function submitFormForGanglinie(theForm) {
		theForm.Show.value="Ganglinie";
		theForm.submit();
	}

//-->
</script>
</head>
<body bgColor="#ffffff">
<h3><u>HTML-Maske aus Pegelonline-Gastbereich basierend auf <i>Pegelonline-Webservice</i>
mit PHP 5</u></h3>
<font color="#FF0000">Achtung: Zeitangabe in den Download-Dateien ist
MEZ!</font>
<form name="form" onsubmit="return validator(this);"
	action="<? echo $PHP_SELF; ?>" method="post">

<table cellSpacing="0" cellPadding="2" width="650" border="0">
	<tbody>
		<tr>
			<td class="formtext" width="207">Parameterauswahl</td>
			<td width="435" colspan="3"><select size="1"
				name="ParameterSelectionList" style="width: 270px"
				onchange="submitForm(document.form);">
				<option value="">Bitte w&auml;hlen Sie einen Parameter aus</option>
				<?php
				foreach ($arrParameter as $parameter) {
					$selected = ($selectedParameter == $parameter->name) ? " selected='selected'" : "";
					echo "<option value='" . $parameter->name . "'" . $selected . ">" . $parameter->name . "</option>\n";
				}
				?>
				</select></td>
		</tr>

</tbody></table>
<br>
<table width="650" border="0" cellspacing="0" cellpadding="0">
	<tr>
		<td width="42%" align="left" height="33">Name des Gew&auml;ssers</td>
		<td width="36%" nowrap align="center" height="33"></td>
		<td width="22%" nowrap align="left" height="33">Ausgew&auml;hltes
		Gew&auml;sser</td>
	</tr>
	<tr>
		<td width="42%" align="left" height="75"><select size="6"
			name="GewaesserLeftSelectionList[]" multiple style="width: 250px">
			<?php
			foreach ($arrGewaesserLeft as $gewaesser) {
				if(!in_array($gewaesser->name, $gewaesserRight)){
					echo "<option value='" . $gewaesser->name . "'>" . $gewaesser->name . "</option>\n";
				}
			}
			?>
		</select></td>
		<td width="36%" nowrap align="center" height="75">
		<div align="center">
		<table border="0" cellspacing="0" width="100%">
			<tr>
				<td width="100%" align="center"><input type="button"
					value="Hinzuf&uuml;gen"
					onClick="init();moveSelectedItemsToRight(gewaesserLeftSelectionList, gewaesserRightSelectionList);selectAll(gewaesserLeftSelectionList);selectAll(gewaesserRightSelectionList);submitForm(document.form);">
				</td>
			</tr>
			<tr>
				<td width="100%" align="center"><input type="button"
					value="Entfernen"
					onClick="init();moveSelectedItemsToRight(gewaesserRightSelectionList, gewaesserLeftSelectionList);selectAll(gewaesserLeftSelectionList);selectAll(gewaesserRightSelectionList);submitForm(document.form);">
				</td>
			</tr>
			<tr>
				<td width="100%" align="center"><input type="button"
					value="Alle entfernen"
					onClick="init();moveAllItemsToRight(gewaesserRightSelectionList, gewaesserLeftSelectionList);selectAll(gewaesserLeftSelectionList);selectAll(gewaesserRightSelectionList);submitForm(document.form);">
				</td>
			</tr>
		</table>
		</div>
		</td>
		<td width="22%" nowrap align="left" height="75"><select size="6"
			name="GewaesserRightSelectionList[]" multiple style="width: 250px">
			<?php
				foreach ($gewaesserRight as $gewaesser) {
					echo "<option value='" . $gewaesser . "'>" . $gewaesser . "</option>\n";
				}

			?>
			<!-- <option value='DAHME-WASSERSTRASSE'>DAHME-WASSERSTRASSE</option>
<option value='ELBE'>ELBE</option>
<option value='ELBE-HAVEL-KANAL'>ELBE-HAVEL-KANAL</option> -->
		</select></td>
	</tr>
	<tr>
		<td width="42%" align="left" height="33">Name der Messstelle</td>
		<td width="36%" nowrap align="center" height="33"></td>
		<td width="22%" nowrap align="left" height="33">Ausgew&auml;hlte Messstelle</td>
	</tr>
	<tr>
		<td width="42%" align="left" height="75"><select size="6"
			name="MessstelleLeftSelectionList[]" multiple style="width: 250px">
			<?php
			foreach ($arrMessstelleLeft as $messstelle) {
				if(!in_array($messstelle->name, $messstelleRight)){
					echo "<option value='" . $messstelle->name . "'>" . $messstelle->name . "</option>\n";
				}
			}
			?>
		</select></td>
		<td width="36%" nowrap align="center" height="75">
		<div align="center">
		<table border="0" cellspacing="0" width="100%">
			<tr>
				<td width="100%" align="center"><input type="button"
					value="Hinzuf&uuml;gen"
					onClick="init();moveSelectedItemsToRight(messstelleLeftSelectionList, messstelleRightSelectionList);selectAll(gewaesserLeftSelectionList);selectAll(gewaesserRightSelectionList);selectAll(messstelleLeftSelectionList);selectAll(messstelleRightSelectionList);submitForm(document.form);">
				</td>
			</tr>
			<tr>
				<td width="100%" align="center"><input type="button"
					value="Entfernen"
					onClick="init();moveSelectedItemsToRight(messstelleRightSelectionList, messstelleLeftSelectionList);selectAll(gewaesserLeftSelectionList);selectAll(gewaesserRightSelectionList);selectAll(messstelleLeftSelectionList);selectAll(messstelleRightSelectionList);submitForm(document.form);">
				</td>
			</tr>
			<tr>
				<td width="100%" align="center"><input type="button"
					value="Alle entfernen"
					onClick="init();moveAllItemsToRight(messstelleRightSelectionList, messstelleLeftSelectionList);selectAll(gewaesserLeftSelectionList);selectAll(gewaesserRightSelectionList);selectAll(messstelleLeftSelectionList);selectAll(messstelleRightSelectionList);submitForm(document.form);">
				</td>
			</tr>
		</table>
		</div>
		</td>
		<td width="22%" nowrap align="left" height="75">
		<table cellpadding="5" cellspacing="0" border="0">
			<tr>
				<td><select size="6" name="MessstelleRightSelectionList[]" multiple
					style="width: 250px">
					<?php
						foreach ($messstelleRight as $messstelle) {
							echo "<option value='" . $messstelle . "'>" . $messstelle . "</option>\n";
						}
					?>
				</select></td>
				<td></td>
			</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td class="formtext" width="200">Zeitbereich</td>
		<td class="formtext">&nbsp;</td>
		<td class="formtext" width="200">&nbsp;</td>
	</tr>
	<tr>
		<td width="200"><select size="1" name="DateFrom" style="width: 250px"
			onchange="init();selectAll(gewaesserLeftSelectionList);selectAll(gewaesserRightSelectionList);selectAll(messstelleLeftSelectionList);selectAll(messstelleRightSelectionList);submitForm(document.form);">
			<option value="">Anfangsdatum</option>
			<?php
			if($datenVerfuegbarkeit != null){
				$dateStart = $clientApi->toDateTime($datenVerfuegbarkeit->start);
				while ($dateStart <= $clientApi->toDateTime($datenVerfuegbarkeit->ende)) {
					$selected = ($dateFrom == $dateStart->format('d.m.Y')) ? " selected='selected'" : "";
					echo "<option value='" . $dateStart->format('d.m.Y') . "'" . $selected . ">" . $dateStart->format('d.m.Y') . "</option>\n";
					$dateStart->modify("+1 day");
				}
			}
			?>
		</select></td>
		<td width="450">&nbsp;</td>
		<td width="200"><select size="1" name="DateTo" style="width: 250px;"
			onchange="init();selectAll(gewaesserLeftSelectionList);selectAll(gewaesserRightSelectionList);selectAll(messstelleLeftSelectionList);selectAll(messstelleRightSelectionList);submitForm(document.form);">
			<option value="">Enddatum</option>
			<?php
			if($datenVerfuegbarkeit != null){
				$dateStart = $clientApi->toDateTime($datenVerfuegbarkeit->start);
				while ($dateStart <= $clientApi->toDateTime($datenVerfuegbarkeit->ende)) {
					$selected = ($dateTo == $dateStart->format('d.m.Y')) ? " selected='selected'" : "";
					echo "<option value='" . $dateStart->format('d.m.Y') . "'" . $selected . ">" . $dateStart->format('d.m.Y') . "</option>\n";
					$dateStart->modify("+1 day");
				}
			}
			?>
		</select></td>
	</tr>
	<tr>
		<td width="200">&nbsp;</td>
		<td>&nbsp;</td>
		<td width="81">&nbsp;</td>
	</tr>
	<tr>
		<td align="center"><input type="Submit" value="Download"
			name="Download"
			onClick="init();selectAll(gewaesserLeftSelectionList);selectAll(gewaesserRightSelectionList);selectAll(messstelleLeftSelectionList);selectAll(messstelleRightSelectionList);submitForm(document.form);">
		</td>
		<td align="center"><input type="Submit" value="Pegelinformationen"
			name="Pegelinformation"
			onClick="init();selectAll(gewaesserLeftSelectionList);selectAll(gewaesserRightSelectionList);selectAll(messstelleLeftSelectionList);selectAll(messstelleRightSelectionList);submitForm(document.form);">
		</td>
		<td align="center">
		<?php
		if(!empty($messstelleRight)){
			$url = "ganglinienimage.php?PegelonlineMessstellen%5B%5D=" .
			implode("&PegelonlineMessstellen%5B%5D=", array_map("utf8_encode",$messstelleRight)) .
								"&PegelonlineParameter=" . urlencode($selectedParameter) . "&DateFrom=" . $dateFrom. "&DateTo=" . $dateTo;


			echo "<a href=\"#\" onclick=\"init();selectAll(gewaesserLeftSelectionList);" .
								 "selectAll(gewaesserRightSelectionList);selectAll(messstelleLeftSelectionList);" .
								 "selectAll(messstelleRightSelectionList);document.form.Show.value='Ganglinie';". 
								 "submitFormForGanglinie(document.form);\">". 
								 "<img src=\"" . $url . "\" border=\"0\"/></a>";

		} else {
			echo "Ganglinien-Icon erscheint nach Messstellenauswahl";
		}
		?>
		<input type="hidden" name="Show"></td>
	</tr>
	<?php
	if(isset($downloadHinweis)){
		echo $downloadHinweis;
	}
	?>
</table>
</FORM>
</BODY>
</HTML>
